// TemplateBlock.h: interface for the CTemplateBlock class.
//

#if !defined(_TemplateBlock_INCLUDED_)
#define _TemplateBlock_INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "resource.h"
#include "Engine/Engine.h"


/////////////////////////////////////////////////////////////////////////////
// CTemplateBlock Class
// 
class CTemplateBlock : public TModule
{
   // Constructors and destructor.
   public:
   CTemplateBlock();
   virtual ~CTemplateBlock();

   // Pure overrides
   public:
   virtual CString InputName(int Point);
   virtual CString OutputName(int Point);
   virtual bool InputActive(int Point);
   virtual bool OutputActive(int Point);
   virtual int InputCount() {return 1;};
   virtual int OutputCount() {return 1;};
   virtual TModule* CreateAnother() 
         {return static_cast<TModule *>(new CTemplateBlock());};

   // Overrides
   public:
   virtual int GetModuleType() {return TModule::PROCESSING;};
   virtual bool ShowProperties(CWnd* pParent);
   virtual void Initialize();
   virtual void Execute(TTime tScheduled);
   virtual void GetData(int nPt, CSensorData& data);
   virtual void SetData(int nPt, const CSensorData& data);
   virtual bool GetIOAddrAsString(CString &string);
   virtual CIODeviceType GetDeviceType();
   virtual void AssignDefaultChannel();
   virtual TProperty* GetModuleProperty();
   virtual TProperty* GetChannelProperty();
   virtual void ClearChannelsInuse();
   virtual void SetChannelsInuse();

   // Attributes
   protected:
   TProperty m_propAIOModule;
   TProperty m_propAIOChannel;
   TProperty m_propDIOModule;
   TProperty m_propDIOChannel;
   TProperty m_propSDIAddressIdx;
   CSensorData m_Out1Data;
};

#endif // !defined(_TemplateBlock_INCLUDED_)
